#!/bin/sh

######################################################################
#                                                                    #
#                 X-Bone 3.1.1 Release                               #
#                                                                    #
#        Shell script to install dependent perl modules on Linux     #
#                                                                    #
######################################################################

# This script creates a temporary directory. Downloads the perl modules
# required by xbone and installs them. 

CWD=`pwd`;
DIR=`pwd`/packages
GET=fetch

# create a temporary directory 
mkdir -p $DIR

# where to download the tar.gz from 
PREFIX="http://search.cpan.org/CPAN/authors/id"
ALTPREFIX="ftp://ftp.cpan.org/pub/CPAN/authors/id"

# NOTE: On Redhat 9 use XML-LibXML-1.54 instead of 1.58 version given in 
# the list below
# ftp://ftp.cpan.org/pub/CPAN/modules/by-module/XML/XML-LibXML-1.54.tar.gz\


for i in  \
	J/JM/JMM/Heap-0.70.tar.gz \
	J/JH/JHI/Graph-0.20102.tar.gz \
	C/CR/CREIN/Net-DNS-0.47.tar.gz \
	U/UM/UMEMOTO/Socket6-0.17.tar.gz \
	M/MO/MONDEJAR/INET6-2.01.tar.gz \
        G/GA/GAAS/Digest-HMAC-1.01.tar.gz \
        D/DP/DPARIS/Crypt-IDEA-1.02.tar.gz \
        B/BT/BTROTT/Crypt-DH-0.03.tar.gz \
        C/CH/CHIPT/Math-GMP-2.03.tar.gz \
        B/BT/BTROTT/Digest-BubbleBabble-0.01.tar.gz \
        V/VI/VIPUL/Crypt-RSA-1.50.tar.gz \
        V/VI/VIPUL/Tie-EncryptedHash-1.21.tar.gz \
        L/LD/LDS/Crypt-CBC-2.08.tar.gz \
        D/DP/DPARIS/Crypt-Blowfish-2.09.tar.gz \
        V/VI/VIPUL/Convert-ASCII-Armour-1.4.tar.gz \
        P/PM/PMQS/Compress-Zlib-1.33.tar.gz \
        G/GA/GAAS/Digest-MD2-2.03.tar.gz \
        E/ED/EDAVIS/Sort-Versions-1.5.tar.gz \
        V/VI/VIPUL/Crypt-Primes-0.50.tar.gz \
        B/BT/BTROTT/Data-Buffer-0.04.tar.gz \
	D/DR/DROLSKY/Net-SSH-Perl-1.25.tar.gz \
	M/MA/MANU/Net-IP-1.20.tar.gz \
	M/MU/MUIR/modules/Net-Netmask-1.9009.tar.gz \
	S/SA/SAMPO/Net_SSLeay.pm-1.25.tar.gz \
	L/LU/LUISMUNOZ/NetAddr-IP-3.20.tar.gz \
	R/RB/RBERJON/XML-NamespaceSupport-1.08.tar.gz \
	P/PH/PHISH/XML-LibXML-Common-0.13.tar.gz \
	P/PH/PHISH/XML-LibXML-1.58.tar.gz \
	M/MS/MSERGEANT/XML-Parser-2.34.tar.gz \
	G/GR/GRANTM/XML-Simple-2.12.tar.gz \
	G/GA/GAAS/libwww-perl-5.79.tar.gz \
	D/DC/DCONWAY/Parse-RecDescent-1.94.tar.gz \
	M/MS/MSERGEANT/XML-SAX-0.12.tar.gz \
	L/LD/LDS/IO-Socket-Multicast-0.25.tar.gz \
	B/BE/BEHROOZI/IO-Socket-SSL-0.95.tar.gz \
	A/AB/ABW/AppConfig-1.56.tar.gz \
	L/LD/LDS/CGI.pm-3.04.tar.gz \
	G/GA/GAAS/Digest-SHA1-2.10.tar.gz \
	G/GA/GAAS/Digest-MD5-2.33.tar.gz \
	G/GA/GAAS/File-CounterFile-1.04.tar.gz \
	T/TJ/TJENNESS/File-Temp-0.14.tar.gz \
	M/MI/MIVKOVIC/Mail-Sendmail-0.79.tar.gz \
	D/DL/DLUX/Parallel-ForkManager-0.7.5.tar.gz \
	; do \
   URL=$PREFIX/$i
   j=`echo $URL | sed "s/.*\///g"| sed "s/.tar.gz//g"`;\
   echo $URL; \
   echo $j; \
   wget -P $DIR $i ; \ 
   tar zxvf $DIR/$j.tar.gz -C $DIR;\
   cd $DIR/$j;\
   perl Makefile.PL;\
   make;\
   make install ;\
   cd $CWD;\
done

#cleanup 
#rm -rf $DIR
