eval '(exit $?0)' && eval 'PERLDB_OPTS="N f=26";export PERLDB_OPTS;PERL=`which perl5`; exec $PERL -wS $0 ${1+"$@"}'
    & eval 'setenv PERLDB_OPTS "N f=26"; setenv PERL `which perl5`; exec $PERL -wS $0 $argv:q'
    if 0;

### Local Variables: ***
### mode:perl ***
### comment-column:0 ***
### comment-start: "### " ***
### comment-end: "***" ***
### End: ***
#
# ****************DO NOT MOVE OR CHANGE LINES ABOVE THIS*********************
#
# The first set of lines runs perl from any shell. The second set of lines
# identifies the rest of the file as PERL for EMACS autoformatting.
# See end of copyright for more information.
#
# ----------------------------------------------------------------------------
#                                   X-BONE
#
#                          http://www.isi.edu/xbone
#                USC Information Sciences Institute (USC/ISI)
#                   Marina del Rey, California 90292, USA
#                          Copyright (c) 1998-2004
# ----------------------------------------------------------------------------
#
# Copyright (c) 1998-2004 by the University of Southern California.
# All rights reserved.
#
# Permission to use, copy, modify, and distribute this software and its
# documentation in source and binary forms for non-commercial purposes and
# without fee is hereby granted, provided that the above copyright notice
# appear in all copies and that both the copyright notice and this permission
# notice appear in supporting documentation, and that any documentation,
# advertising materials, and other materials related to such distribution and
# use acknowledge that the software was developed by the University of
# Southern California, Information Sciences Institute.  The name of the
# University may not be used to endorse or promote products derived from this
# software without specific prior written permission.
#
# THE UNIVERSITY OF SOUTHERN CALIFORNIA MAKES NO REPRESENTATIONS ABOUT THE
# SUITABILITY OF THIS SOFTWARE FOR ANY PURPOSE.  THIS SOFTWARE IS PROVIDED "AS
# IS" AND WITHOUT ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, WITHOUT
# LIMITATION, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
# PARTICULAR PURPOSE.
#
# Other copyrights might apply to parts of this software and are so noted when
# applicable.
#
# ----------------------------------------------------------------------------
#
# Effort sponsored by the Defense Advanced Research Projects Agency
# (DARPA) and Air Force Research Laboratory, Air Force Materiel
# Command, USAF, under agreement numbers F30602-98-1-0200 and
# F30602-01-2-0529, and by National Science Foundation under agreement
# number ANI-0230789. The U.S. Government is authorized to reproduce
# and distribute reprints for Governmental purposes not withstanding
# any copyright annotation therein.  The views and conclusions
# contained herein are those of the authors and should not be
# interpreted as necessarily representing the official policies or
# endorsements, either expressed or implied, of the Defense Advanced
# Research Projects Agency (DARPA), the Air Force Research Laboratory,
# or the U.S. Government.
#
# ----------------------------------------------------------------------------
#  $RCSfile: xb-config.pl,v $
#
# $Revision: 1.23 $
#   $Author: pingali $
#     $Date: 2004/04/29 00:48:25 $
#    $State: Exp $
# ----------------------------------------------------------------------------
#
############################################################
#
# The first lines start PERL on any system where perl is in the path.
# This is a modified version of the "start perl" script
# provided in the PERL man pages, which starts perl
# on the remainder of the file regardless of whether it
# is run under sh, csh, or perl.
#
# This version is modified to dynamically locate the
# perl path, rather than requiring it be hard-coded.
#
# setenv PERLDB_OPTS "N f=26"
#
# Must be set before perl starts!
#
# N 	: Nonstop (noninteractive)
# f=26	: frame=26 = 16 + 8 + 2,
#		2 = entry and exit,
#		!4 = don't print args to functions
#		8= enabled overloaded stringify and tied FETCH
#		16= print return values from subroutines
#
# note - '-T' (TAINT) switch is not included, because 'which' often
# returns a version of perl that isn't secure. don't worry about it.
#
############################################################
# PERL CODE STARTS HERE
############################################################

# XBONE code to set libraries
BEGIN {
  use strict;
  use sigtrap;
  use FindBin;
  use Config; 
  delete $ENV{PATH};

  # taint-safe backticks equivalent
  my $pid = open KID, "-|";
  unless(defined $pid) { die "open: $!"; }
  unless($pid) {
    foreach my $uname ("/usr/bin/uname", "/bin/uname") {
      if(-x $uname) { exec $uname, "-msr" or die "exec: $!"; }
    }
    die "cannot find uname";
  }
  my ($osname, $osvers, $arch) = split ' ', lc <KID>;
  close KID or die "close: $!";
  $osvers =~ s/^(\d+\.\d+).*/$1/;

  if($osname eq "linux") {
    # same for Linux
    if($arch eq "i686") { $arch =~ s/i\d(\d+)/i3$1/; }
  } elsif($osname eq "freebsd") {
    if($osvers =~ /cairn/) { $osvers = "2.2"; }
  }

  my $ostag = join "-", ($arch, $osname, $osvers);
  print "Configuring perl for $ostag...\n" if 0;

  my $ldir = "/usr/local/xbone";
  my $version = $Config{'version'};
  $arch = $Config{'archname'};

  foreach my $p 
    ( 
     "$ldir/programs/modules", 
     "$ldir/programs/modules/cpan",
     "$ldir/programs/modules/cpan/lib/perl5/$version",
     "$ldir/programs/modules/cpan/lib/perl5/$version/$arch",
     "$ldir/programs/modules/cpan/lib/perl5/site_perl/mach",
     "$ldir/programs/modules/cpan/lib/perl5/site_perl/mach/$arch",
     "$ldir/programs/modules/cpan/lib/perl5/site_perl/$version",
     "$ldir/programs/modules/cpan/lib/perl5/site_perl/$version/$arch",
     "$ldir/programs/modules/cpan/lib/perl5/site_perl/$version/mach", 
     "$ldir/programs/modules/cpan/lib/perl5/site_perl/$version/mach/$arch", 
     "$ldir/www", 
     "$ldir/www/cpan",
     "$ldir/www/cpan/lib/perl5/$version",
     "$ldir/www/cpan/lib/perl5/$version/$arch",
     "$ldir/www/cpan/lib/perl5/site_perl/mach",
     "$ldir/www/cpan/lib/perl5/site_perl/mach/$arch",
     "$ldir/www/cpan/lib/perl5/site_perl/$version",
     "$ldir/www/cpan/lib/perl5/site_perl/$version/$arch",
     "$ldir/www/cpan/lib/perl5/site_perl/$version/mach",
     "$ldir/www/cpan/lib/perl5/site_perl/$version/mach/$arch"
    ){
      if(-d $p) { unshift   @INC, $p; }
  }

  # untaint the resulting include path so "use" works
  foreach my $i (@INC) { if($i =~ /(.*)/) { $i = $1;} }

  printf STDERR "\n%s\n\n", join "\n", @INC if 0;
};

##############################################################################
# END OF XBONE PREFIX CODE - PUT YOUR PERL CODE BELOW                        #
##############################################################################

# Primary Author: Gregory G. Finn

use strict;
use sigtrap;

use Data::Dumper;
use Sys::Hostname;
use Term::ReadLine;
use Socket;
use Socket6;
use IO::Socket;
use FileHandle;
use Config;


##########################################
# Global declaration initialization.
##########################################



sub init_nodedb ($) {
  my ($href) = @_;
  my $os = $Config{osname};

#  %$href = ( ID => hostname(),
#	     daemon_type => 'node',
#	     IPversion => 'IPv4',
#	     OverlayCount => 0x0,
#	     MaxOverlayCount => 0x0,
#	     TunnelCount => 0x0,
#	     MaxTunnelCount => 0x0,
#	     IPaddr => '0.0.0.0',
#	     Dummynet => 'no',
#	     Authentication => 'none',
#	     Encryption => 'none',
#	   );

}
		



sub init_acl ($$)
{
    my ($href, $nodehref) = @_;

#    %$href = (
#		 UserAuth => '\S*',
#		 ID => $nodehref->{'hostname'},
#		 AccessLevel => 'deploy',
#		 OverlayCount => 0x0,
#		 MaxOverlayCount => 0x0,
#		 TunnelCount => 0x0,
#		 MaxTunnelCount => 0x0
#             );

}




sub get_integer ($$)
{
    my ($prompt, $lref) = @_;
    my ($str, $pat);

    while (1)
    {
	print "$prompt: (range $lref->[0] to $lref->[1]) ";

	$str = <STDIN>;
	chomp $str;

	if ($str !~ /^[0-9]+\Z/)
	{
	   print "\aNot an integer, retry: (range $lref->[0] to $lref->[1]) ";
	   next;
        };

	if ($str < $lref->[0])
	{
	   print "\aToo small, retry: (range $lref->[0] to $lref->[1]) ";
	   next;
        }
	elsif ($str > $lref->[1])
	{
	   print "\n\aToo large, retry: (range $lref->[0] to $lref->[1]) ";
	   next;
        };

	last;
    }

    return ($str);
}




sub get_dotted_decimal ($;$)
{
    my ($prompt, $default) = @_;
    my ($str);

    while (1)
    {
	print "$prompt: [dotted decimal x.x.x.x] ";

	if ($default)
	{ print "($default) "; }

	$str = <STDIN>;
	chomp $str;

	if (!$str)
	{
	    $str = $default;
	    last;
	}
	elsif ($str !~ /^[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\Z/)
	{
	   print "\n\aIncorrect dotted decimal address, retry: ";
	   next;
        };

	last;
    }

    return ($str);
}




sub get_string ($;$)
{
    my ($prompt, $default) = @_;
    my ($str, $pat);

GETSTR:
    while (1)
    {
	if (defined ($default))
	{ print "$prompt: ($default) "; }
	else
	{ print "$prompt: "; }

	$str = <STDIN>;
	chomp $str;
	if (!$str) { $str = $default; };

	last;
    }

    return ($str);
}




sub get_oneof ($$)
{
    my ($prompt, $lref) = @_;
    my ($str, $pat);

GETSTR:
    while (1)
    {
	print "$prompt: ($lref->[0]) ";

	$str = <STDIN>;
	chomp $str;
	if (!$str) { $str = $lref->[0];  last GETSTR; };

        foreach $pat (@$lref)
	{ if ($str =~ /$pat/i) { last GETSTR; }; }

	print "\n\aNot acceptable, retry: ($lref->[0]) ";
    }

    return ($str);
}




sub get_someof ($$)
{
    my ($prompt, $lref) = @_;
    my (@str, $str, $match, $pat);

    $match = 0;

SOMEOF:
    while (1)
    {
	print "$prompt: ($lref->[0]) ";

	$_ = <STDIN>;
	chomp $_;
	if (!$_) { @str = ($lref->[0]);  last SOMEOF; };

	@str = split /[, \t\n\r\f]+/;

	foreach $str (@str)
	{
	    $match = 0;

	    foreach $pat (@$lref)
	    { if ($str =~ /$pat/i) { $match = 1;  last; }; }

	    if (!$match)
	    {
		print "Choice of $str is unacceptable, retry: ($lref->[0]) ";
		next SOMEOF;
	    }
	}

	last SOMEOF;
    }

    return "@str";
}




sub fillin_nodedb ($)
{
    my ($href) = @_;
    my @candidates;

    init_nodedb ($href);		# Fill in some global defaults.

    print "\n              Host Information                ";
    print "\n           ~~~~~~~~~~~~~~~~~~~~~~~           \n";
    $href->{'hostname'} = `hostname`;
    chomp $href->{'hostname'};
    $href->{'hostname'} =
      get_string ("Hostname", $href->{'hostname'});

    print "\n           Configuration File Path             ";
    print "\n           ~~~~~~~~~~~~~~~~~~~~~~~           \n";
    $href->{'prefix'} =
      get_string ("Specify directory where configuration files ".
		  "are to be\nstored", $href->{'prefix'});
    if ($href->{'prefix'} ne "/usr/local/etc/xbone"){
      print 
	"\n. Please make sure you edit \n".
        "        /usr/local/xbone/programs/XB_Params.pm         \n".
	"with the new location of the configuration file. Look \n".
	"for the variable \n". 
        "              \$XB_Params::conf             \n".
	"in XB_Params.pm. Alternatively use the command line \n".
	"option -c to specify the location of the configuration file \n";
    }

    print "\n             Node Capabilities           ";
    print "\n             ~~~~~~~~~~~~~~~~~           \n";

    @candidates = ("host", "router", "node", "meta");
    $href->{'daemon_type'} =
	get_oneof ("The type of node. Select one of ". 
		   "{host, router, node, meta, all}.".
	"\n    router: the host acts as a router in the overlay".
	"\n    host:   the host acts as a normal host (not router)".
	"\n    node:   the host acts as a host or router depending on need".
	"\n    meta:   the host acts as a overlay manager (see documentation)".
        "\n\n    Your Selection ",
		   \@candidates);


    if ($href->{'daemon_type'} eq "meta"){
      #$href->{'ovl_manager'} =
      #	get_string ("Which other overlay managers should this node listen to\n(Specify a list of hostname separated by space)",
      #		    "www.xbone.net");
      $href->{'ovl_manager'} .= " $href->{hostname}";
      $href->{'addrserv'} = 1; 
    } else {
      $href->{'ovl_manager'} =
	get_string ("Which overlay managers should this node listen to\n(Specify a list of hostname separated by space)",
		    "www.xbone.net");
    }
    $href->{'ovl_manager'} =~ s/^\s+//g;
    my $main_ovl_manager = $href->{'ovl_manager'};
    $main_ovl_manager =~ s/[,]?\s.*$//g;
    $href->{'ovl_manager'} =~ s/[,]?\s/ /g;
    #$href->{'ovl_manager'} = "{ $href->{'ovl_manager'} }";

    @candidates = (1, 1000);
    $href->{'max_overlay_count'} =
      get_integer ("Maximum number of overlays supported by this node", \@candidates);

    print "\n             Addresses and Ports           ";
    print "\n             ~~~~~~~~~~~~~~~~~~~           \n";

    @candidates = ("ipv4", "ipv6", "both");
    $href->{'address_type'} =
	get_oneof ("Type of overlays to be supported. Select one of {ipv4, ipv6, both}", \@candidates);
    $href->{'ipproto'} = $href->{'address_type'};

    @candidates = ("ipv4", "ipv6", "both");
    $href->{'control_protocol'} =
      get_oneof ("\nSpecify The control protocol that must be used." . 
		 "This is typically the same as \ntype of the overlays." .
		 "Select one of {ipv4, ipv6, both}", \@candidates);

    @candidates = ("yes", "no");
    my $addrsetting =  
      get_oneof ("Would you like to set any ip addresses? " . 
		 "Select one of {yes, no}", \@candidates); 

    if ($addrsetting eq "yes"){
      my ($family, $socktype, $proto, $saddr, $canonname);
      if ($href->{'address_type'} =~ /(ipv4|both)/){
	my @res = getaddrinfo($href->{'hostname'}, 
			       'daytime', # dummy service 
			       AF_INET);
	my $ctl_addr; 
	if (scalar(@res) < 5) {
	  #die ("unknown hostname to compute v4 address $#hostent") 
	  $ctl_addr = "127.0.0.1"; # dont die. just store 
	} else {
	  # the v6 lookup can return multiple ip addresses some of
	  # which may not work. So, try all of them.
	  $family = -1; # for safety 
	  ($family, $socktype, $proto, $saddr, $canonname, @res) 
		             = @res;
	  my ($host, $dummyport) = 
		 getnameinfo($saddr, NI_NUMERICHOST | NI_NUMERICSERV); 

	  $ctl_addr = $host;
      }

	$href->{'ctl_addr'} =
	  get_string ("IPv4 address to be used for Node Daemon communication",
		      $ctl_addr); 

         $href->{'app_addr'} =
	   get_string ("IPv4 address to be used for tunnel endpoints. If".
		       " this node is acting as Cisco buddy, then this is".
		       " Cisco's router's address. If you are not sure,".
		       " press enter", $href->{'ctl_addr'}); 
      } # ipv4

      if ($href->{'address_type'} =~ /(ipv6|both)/){
	my @res = getaddrinfo($href->{'hostname'}, 
				'daytime', # dummy service 
				AF_INET6);
	my $ctl_addr6; 
	if (scalar(@res) < 5) {
	  #die ("unknown hostname to compute v4 address $#hostent") 
	  $ctl_addr6 = "::1"; # dont die. just store 
	} else {
	  while(scalar(@res) >= 5) {
	      # the v6 lookup can return multiple ip addresses some of
	      # which may not work. So, try all of them.
	      $family = -1; # for safety 
	      ($family, $socktype, $proto, $saddr, $canonname, @res) 
		         = @res;
	      my ($host, $dummyport) = 
		 getnameinfo($saddr, NI_NUMERICHOST | NI_NUMERICSERV); 

	      if (not defined $ctl_addr6){     
		  $ctl_addr6 = $host; 
	      } else {
		  # this doesnt look right. comparing 2001 with 
		  # binary representation? 
		  if ($host =~ /^2001/){
		      $ctl_addr6 = $host;
		  }
	      }
	  } #while...
        }
	$href->{'ctl_addr6'} =
	  get_string ("Please enter the IPv6 address to be used for " .
		      "Node Daemon communication", $ctl_addr6);
         $href->{'app_addr6'} =
	   get_string ("Please enter the IPv4 address to be used for ". 
		       "tunnel endpoints", $href->{'ctl_addr6'});
      } # ipv6
      
      if ($href->{'control_protocol'} =~ /(ipv4|both)/){
	$href->{'xbone_mcast_addr'} =
	  get_string ("Please enter the IPv4 multicast address that " . 
		      "must be used", "224.192.0.1");
      }

      if ($href->{'control_protocol'} =~ /(ipv6|both)/){
	$href->{'xbone_mcast_addrv6'} =
	  get_string ("Please enter the IPv6 multicast address that ".
		      "must be used", "FF0c:0:0:0:0:0:0:6061");
      }
    }

    #$href->{'xbone_api_port'} =
    #  get_string ("Please specify the port over which Node Daemon and GUI communicate",
    #		  "2165"); 
    #$href->{'xbone_ctl_port'} =
    #  get_string ("Please specify the port over which Node Daemons communicate",
    #		  "265"); 
    #
    #print "Please ensure that all nodes are configured with the same port numbers";  

    
    if ($href->{daemon_type} eq "meta"){
      print "\n             DNS  Information           ";
      print "\n             ~~~~~~~~~~~~~~~~           \n";

      @candidates = ("yes", "no");
      $href->{'dns'} =
	get_oneof ("Should this node support Dynamic DNS updates. ". 
		   "Select either yes or no ",\@candidates );

      if ($href->{'dns'} eq "yes"){
	$href->{'name_server'} =
	  get_string ("Specify the host running BIND name server ".
		      "(version 9.2.2 or higher)","$main_ovl_manager" );
	
	$href->{'dns_key_file'} =
	  get_string ("Specify the file containing the key",
		      $href->{prefix}. "/Kkey-test.+157+32035.key" );
      }
    }# end 

    print "\n             X.509 Certificates           ";
    print "\n             ~~~~~~~~~~~~~~~~~~           \n";
    $href->{'ca_cert'} =
      get_string ("Enter the location of the Root Certificate",
		  $href->{prefix} . "/cert/CAcert.pem" );
    $href->{'ca_path'} =  $href->{'ca_cert'};
    $href->{'ca_path'} =~ s/\/[^\/]*$//g;

    #$href->{'hostname'} =
    #	get_string ("Certificate name for this node - usually hostname",
    #	    $href->{'hostname'}. "cert.pem");

    $href->{'node_cert'} =
	get_string ("Specify the SSL certificate for this node",
		    "$href->{ca_path}/$href->{'hostname'}.cert.pem");

    $href->{'node_key'} =
	get_string ("Specify the SSL key for this node",
		    "$href->{ca_path}/$href->{'hostname'}.key.pem");

   
    print "\n           Cisco Buddy Information         ";
    print "\n         ~~~~~~~~~~~~~~~~~~~~~~~~~~~         \n";
    @candidates = ('No', 'Yes');
    my $result = get_oneof( "Do you wish to use this node".
    " as Cisco Buddy?", \@candidates);
    if ($result =~ /yes/i) {
      $href->{'os'} = "cisco";
      $href->{'os_version'} = "1";
      $href->{'kern_version'} = "1";

      $href->{'cisco_buddy_username'} = get_string("Please enter".
      " the usename to access the Cisco Router"); 
      $href->{'cisco_buddy_password'} = get_string("Please enter".
      " the password to enter the user EXEC session");
      $href->{'cisco_buddy_enable_password'} = get_string("Please".
      " enter the password to enter the privileged EXEC session");
    }
    
    print "\n                Miscellaneous                ";
    print "\n             ~~~~~~~~~~~~~~~~~~~           \n";

    $href->{'xbone_net'} = "xbone.overlay";
    $href->{'xbone_net'} =
	get_string ("Specify the prefix of the overlays.",
		    $href->{'xbone_net'}); 

    printf("\nPlease make sure that the prefix is consistent ".
	   "with the DNS configuration\n");

}




sub fillin_acl ($)
{
    my ($nodehref) = @_;
    my %acl = ();
    my @candidates;

    init_acl (\%acl, $nodehref);		# Fill in some global defaults.

    
    @candidates = ("1", "65536");
    $acl{'number'} = get_integer("Rule number: ", \@candidates); 

    $acl{'id'} = "\\S+";
    $acl{'id'} =
	get_string ("Define a user set.  This is a Perl pattern string.", $acl{'id'});

    @candidates = ("deploy", "guest", "manage");
    $acl{'access_level'} =
	get_oneof ("Define the access control for this user set. " .
		   "One of \n{deploy, guest, manage}", \@candidates);

    @candidates = (1, $nodehref->{'max_overlay_count'});
    $acl{'max_overlays'} =
	get_integer ("The maximum number of overlays supported for this \nuser set",
		     \@candidates);

    @candidates = ("guest", "root", "nobody", "other");
    $acl{'uid'} =
      get_oneof ("Specify the UID with which application deployment scripts \n".
		 "should be run", \@candidates);
    if ($acl{'uid'} eq "other"){
      $acl{'uid'} =
	get_string ("Specify the UID", "");
    }

    return \%acl;
}


sub fillin_acldb ($$) {
  my ($nodehref, $acldb) = @_;

  print "\n             Access  Control              ";
  print "\n             ~~~~~~~~~~~~~~~~           \n";

  print "\nAt least one Access Control List (ACL) must be created to define\n";
  print "a set of users who are allowed to create/modify an overlay.\n\n";

  while (1)
    {
      my $aclhref = fillin_acl ($nodehref);
      push (@{$acldb}, $aclhref);

      print "\nThat completes the definition of one ACL set.\n";

      my @candidates = ('No', 'Yes');
      my $result = get_oneof ("Do you wish to define another ACL set?", \@candidates);
      if ($result =~ /no/i) { last; };
    }
}




sub write_node ($$$)
  {
    my ($fh, $nodehref, $acldb) = @_;
    my (@keys, $key);

    print $fh "#************ X-Bone Configuration *************\n";
    print $fh "#  * This file has been automatically generated  *\n";
    print $fh "#  * Consult the documentation for more          *\n";
    print $fh "#  * information on how to set the variable in   *\n";
    print $fh "#  * file configuration file.                    *\n";
    print $fh "#*************************************************\n";
    print $fh "\n\n";
    my @variables = (		     
		     "hostname", 
		     "daemon_type","addrserv", "address_type", 
		     "control_protocol",
		     "ipproto", "ctl_addr", "app_addr", "ctl_addr6", 
		     "app_addr6", "xbone_mcast_addr", "xbone_mcast_addrv6",
		     "dns","name_server", "dns_key_file",
		     "ca_path",
		     "ca_cert","node_cert","node_key",
		     "xbone_net",
		     # below used by cisco
		     "os", "os_version", "kern_version",
		     "cisco_buddy_username", "cisco_buddy_password",
		     "cisco_buddy_enable_password",
		    );
    
    foreach $key (@variables){
      if (defined $nodehref->{$key}){
	print $fh "$key = $nodehref->{$key}\n";
      }
    }

    print $fh "\n\n";
    my @mgrlist = split(' ', $nodehref->{'ovl_manager'});
    foreach my $mgr (@mgrlist){
      print $fh "ovl_manager = $mgr\n";
    }

    print $fh "\n\n";
    print $fh "#************* Access Control ******************\n";
    foreach my $aclref (@{$acldb}){
      print $fh "acl $aclref->{number} = $aclref->{id} $aclref->{access_level} ".
	"$aclref->{max_overlays} $aclref->{uid}\n"; 
    }
  }




#####################################################################
#####################################################################
##
## MAIN ()
##
#####################################################################
#####################################################################

STDERR->autoflush(1);
STDOUT->autoflush(1);

my %nodedb = ();

my (@candidates, $result, $nodehref, $aclhref, @acldb);
my ($fh, $configuration, @aclhrefs);

#take the prefix from the command line
if ($#ARGV >= 0){ 
  $nodedb{prefix} = $ARGV[0];
} else {
  $nodedb{prefix} = "/usr/local/etc/xbone";
} 

print "\n###########################################";
print "\n       X-Bone Version 3.1.1 Software       ";
print "\n            Configuration                  ";
print "\n###########################################";
print "\n\n";

# now read in all the variables.
$nodehref = \%nodedb;
fillin_nodedb ($nodehref);
fillin_acldb ($nodehref, \@acldb);



###############################
# Determine where to write it.
###############################

while (1)
{
    $result = get_string ("\n\nFile for this configuration: ",
			  $nodehref->{prefix} . "/xbone.conf");

    $fh = new FileHandle "> $result";
    if (!defined ($fh))
    {
	print "\n\aCould not open: $result.";
	next;
    }

    last;
}

#####################
# Write the XboneNode
# portion.
#####################

write_node ($fh, $nodehref, \@acldb);
print $fh "\n";

$fh->close;

print "\nFinished writing: $result\n\n";

if ($result ne "/usr/local/etc/xbone/xbone.conf"){
    print "\nThe chosen path ($result) is not the default path.\n"; 
    print "Use \"-c\" option with xb-node-daemon to specify this \n";
    print "configuration file\n"; 
}

exit (0);
